/*
                    MPU6050 C51ݲɼ
 ******************************************************************************
         : Luther
     : 2022328
     : MPU60506ٶȴʹøúҪ
	StartTimer(1,50);
	
	 main.c нгʼ
	Ȩ (C), 2022, ̩Ƽ޹˾
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "mpu6050_i2c.h"

void IIC_Start(void)
{
	SDA_OUT();     		//sda
	IIC_SDA=1;
	IIC_SCL=1;
	delay_us(15);
 	IIC_SDA=0;			//START:when CLK is high,DATA change form high to low
	delay_us(15);
	IIC_SCL=0;			//ǯסI2Cߣ׼ͻ
	delay_us(15);
}

void IIC_Stop(void)
{
	SDA_OUT();			//sda
	IIC_SDA=0;			//STOP:when CLK is high DATA change form low to high
	IIC_SCL=1;
 	delay_us(15);
	IIC_SDA=1;			//I2C߽ź
	delay_us(15);
	SDA_IN();
}

/*ȴӦźŵ,  1Ӧʧ 0Ӧɹ  */
void IIC_Wait_Ack(void)	// ǵһֽ֮ȴӦźACKĵ
{
	u8 i=0;
	SDA_IN();      		//SDAΪ
	IIC_SDA=1;
	delay_us(5);
	IIC_SCL=1;
	delay_us(5);
	for(i=0;i<50;i++)
	{
		if(!IIC_SDA)
		{
			break;
		}
		delay_us(5);
	}
	IIC_SCL=0;			//ʱ0
	delay_us(5);
	SDA_OUT();
}

void IIC_Ack(void)	//Ӧ
{
	SDA_OUT();
	IIC_SDA=0;
	delay_us(5);
	IIC_SCL=1;
	delay_us(5);
	IIC_SCL=0;
	delay_us(5);
}

void IIC_NAck(void)	//Ӧ
{
	SDA_OUT();
	IIC_SDA=1;
	delay_us(5);
	IIC_SCL=1;
	delay_us(5);
	IIC_SCL=0;
	delay_us(5);
}


void IIC_Send_Byte(u8 txd)
{
	u8 t;
	SDA_OUT();
	for(t=0;t<8;t++)
	{
		if(txd&0x80)
		{
			IIC_SDA=1;
		}
		else
		{
			IIC_SDA=0;
		}
		txd=(txd<<1);
		delay_us(5);
		IIC_SCL=1;
		delay_us(5);
		IIC_SCL=0;
		delay_us(5);
	}
	IIC_Wait_Ack();
}

u8 IIC_Read_Byte(void)			//ֽ  0 / 1 ѡǷҪӦ
{
	u8 i,receive=0;
	SDA_IN();				//SDAΪ
  for(i=0;i<8;i++)
	{
		delay_us(5);
		IIC_SCL=1;
		delay_us(5);
		receive<<=1;
		if(IIC_SDA)
		{
			receive=receive|0x01;
		}
		else
		{
			receive=receive&0xFE;
		}
		IIC_SCL=0;
		delay_us(5);
  }
    return receive;
}

/**
 * @brief	read one byte from the specified address of the eeprom
 * @param addr the eeprom address will be read from
 * @retval     the read data
 */
u8 MPU6050_ReadOneByte(u16 addr)
{
	u8 temp=0;
	//printf("\nread addr=%x\n",ReadAddr);
	IIC_Start();
	IIC_Send_Byte(SlaveAddressW);

	IIC_Send_Byte(addr);

  IIC_Stop();

  IIC_Start();
	IIC_Send_Byte(SlaveAddressR);

	temp=IIC_Read_Byte();
  IIC_NAck();
	IIC_Stop();
	//printf("\nread byte=%x\n",temp);
	return temp;
}

/**
 * @brief	read multibytes from the specified address of the eeprom
 * @param[in] addr the eeprom address will be read from
 * @param[in] buf 	Pointer to data buffer
 * @param[in] len	amount of data to be read
 * @retval    null
 */
void MPU6050_ReadLenByte(u16 addr,u8 *buf,u16 len)
{
	//printf("\nread len addr=%x\n",ReadAddr);
	IIC_Start();
	IIC_Send_Byte(SlaveAddressW);

	IIC_Send_Byte(addr);

	IIC_Stop();

	IIC_Start();
	IIC_Send_Byte(SlaveAddressR);

	while(len > 1)
	{
		*buf++ = IIC_Read_Byte();
		IIC_Ack();
		//printf("\nread byte=%x\n",*(pBuffer - 1));
		len --;
	}
  *buf = IIC_Read_Byte();
  IIC_NAck();
	IIC_Stop();
}

/**
 * @brief	write one byte to the specified address of the eeprom
 * @param addr the eeprom address will be write to
 * @retval     null
 */
void MPU6050_WriteOneByte(u16 addr, u8 dat)
{
	IIC_Start();
	IIC_Send_Byte(SlaveAddressW);
	IIC_Send_Byte(addr);
	IIC_Send_Byte(dat);
 	IIC_Stop();
	delay_us(100);
}

/**
 * @brief	check the MPU6050 is normal or not
 * @retval
 *     0---success
 *     1---failed
 * @note
 *	different MPU6050 chip will use the different addr
 */
u8 MPU6050_Check(void)
{
	u8 temp;
	temp = MPU6050_ReadOneByte(WHO_AM_I);

	printf("MPU6050 CHECK: %.2X \n",temp);
	return 1;
}

void InitMPU6050()
{
	MPU6050_WriteOneByte(PWR_MGMT_1, 0x00);	//״̬
	MPU6050_WriteOneByte(SMPLRT_DIV, 0x07);
	MPU6050_WriteOneByte(CONFIG, 0x06);
	MPU6050_WriteOneByte(GYRO_CONFIG, 0x18);
	MPU6050_WriteOneByte(ACCEL_CONFIG, 0x01);
}



/**
 * @brief	read multibytes from the specified address of the eeprom
 * @param[in] addr the eeprom address will be read from
 * @param[in] buf 	Pointer to data buffer
 * @param[in] len	amount of data to be read
 * @retval    null
 */
void MPU6050_Read(u16 addr, u8 *buf, u16 len)
{
	while(len)
	{
		*buf++=MPU6050_ReadOneByte(addr++);
		len--;
	}
}

/**
 * @brief	write multibytes from the specified address of the eeprom
 * @param[in] addr the eeprom address will be read from
 * @param[in] buf 	Pointer to data buffer
 * @param[in] len	amount of data to be write
 * @retval    null
 */
void MPU6050_Write(u16 addr, u8 *buf, u16 len)
{
	while(len--)
	{
		MPU6050_WriteOneByte(addr,*buf);
		addr++;
		buf++;
	}
}

u16 GetData(u8 REG_Address)
{
	u8 H,L;
	H=MPU6050_ReadOneByte(REG_Address);
	L=MPU6050_ReadOneByte(REG_Address+1);
	return (H<<8)+L;   //ϳ
}


//**************************************
//1602ʾ10λ
//**************************************
void DisplayData(int value,u8 x,u8 y8)
{
	u8 i;
	//value/=64;					//תΪ10λ
	//lcd_printf(dis, value);			//תʾ
	for(i=0;i<6;i++)
	{
    //   SeriPushSend(dis[i]);
  }
    // 	DisplayListChar(x,y,dis,4);	//ʼУУʾ飬ʾ
	printf(" %4d ",value);
}


int MPU6050_Run() //ԪԺ 
{
	u8 *testbuf = "MPU6050 I2C RUNING ...";
	u8 datatmp[32];

	u8 times=100;

	printf("%s\n",testbuf);

 //   wm_i2c_scl_config(WM_IO_PA_01);  // WM_IO_PA_01
 //   wm_i2c_sda_config(WM_IO_PA_04);  // WM_IO_PA_04
	
	//tls_i2c_init(I2C_FREQ);
	
  InitMPU6050();

	MPU6050_Check();

  while(times--)
	{
	   printf("ACCEL XYZ: %4X ,%4X ,%4X     ",GetData(ACCEL_XOUT_H),GetData(ACCEL_YOUT_H),GetData(ACCEL_ZOUT_H)); // X,Y,Zٶ
	   printf("GYRO  XYZ%4X ,%4X ,%4X     ",GetData(GYRO_XOUT_H),GetData(GYRO_YOUT_H),GetData(GYRO_ZOUT_H)); // X,Y,Z ٶ

	   printf("\n");
		//DisplayData(GetData(ACCEL_XOUT_H),2,0);	//ʾXٶ
		//DisplayData(GetData(ACCEL_YOUT_H),7,0);	//ʾYٶ
		//DisplayData(GetData(ACCEL_ZOUT_H),12,0);	//ʾZٶ
		//DisplayData(GetData(GYRO_XOUT_H),2,1);	//ʾXٶ
		//DisplayData(GetData(GYRO_YOUT_H),7,1);	//ʾYٶ
		//DisplayData(GetData(GYRO_ZOUT_H),12,1);	//ʾZٶ

		delay_ms(100);
	};

	delay_ms(50);
	printf("MPU6050 testing success\n");

	memset(datatmp,0,sizeof(datatmp));

	MPU6050_ReadLenByte(0,(u8 *)datatmp,sizeof(datatmp));
	printf("Read data is:%s\n",datatmp);

	return 0;
}


